// Log.cpp: implementation of the CLog class.
//
//////////////////////////////////////////////////////////////////////
#include <windows.h>
#include "Log.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLog::CLog()
{
//	MessageBox(NULL, "CLog::CLog", "!", MB_OK);
	
	logentrance = 0;
	InitializeCriticalSection(&cs);
}

CLog::~CLog()
{
	DeleteCriticalSection(&cs);
}

void CLog::CreateFile(char *fname)
{
	strcpy(FileName, fname);
	LogFile = fopen(FileName, "wt");
}

char* CLog::SkipPath (char *pathname)
{
	char    *last;
	
	last = pathname;
	while (*pathname)
	{
		if ((*pathname=='/') || (*pathname=='\\'))
            last = pathname+1;
		pathname++;
	}
	return last;
}



void CLog::StripExtension( const char *in,  char *out )
{
	while ( *in && *in != '.' )
	{
		*out++ = *in++;
	}
	*out = 0;
}

char* CLog::fwoext(char *fname)
{
	char *nm;
	
	nm=SkipPath(fname);
	StripExtension(nm, nn);
	
	return nn;
}

void CLog::AddLine(char *module, char *fmt, ...)
{
    if( NULL == LogFile ) return;
	EnterCriticalSection(&cs);
    char *mdl;
    va_list ap;

    mdl=SkipPath(module);

	  
//     fprintf(LogFile, "\n[%02d.%02d:%02d.%03d]:%-12s:", syst.wHour,syst.wMinute,syst.wSecond,syst.wMilliseconds, mdl);
    fprintf(LogFile, "\n[%08X]:%-12s:", (DWORD)GetCurrentThreadId(), mdl);

    va_start(ap, fmt);
	vsprintf(logbuff, fmt, ap);
    va_end(ap);
	
	fprintf(LogFile, logbuff);

    fflush(LogFile);

	strcat(logbuff, "\n");
	LeaveCriticalSection(&cs);

//	if (konzola!=NULL)	konzola(pkonzola, logbuff);
}

void CLog::CloseFIle()
{
	if( NULL != LogFile )
	{
		fclose(LogFile);
		LogFile = NULL;
	}
}
