#pragma once
#include "glextmap.h"
#include <vector>
#include <string>


class GLSLShaderObject
{
public:
	GLSLShaderObject(void);
	~GLSLShaderObject(void);
	int LoadFromFile(const char* fname, GLint type);
	void Delete();

	GLhandleARB object;
	std::string m_Name;
};

typedef struct tagGLSLUniform
{
	std::string name;
	GLenum type;
	GLint size;
} tGLSLUniform;

class CGLSLProgramObject
{
public:
	CGLSLProgramObject(const char *name);
	virtual ~CGLSLProgramObject(void);
	int AttachShader(GLSLShaderObject* shader);
	int Link();
	int Bind();
	int Unbind();
	void GetUniforms();
	void Dump();

	void sendUniform(const char *name, float x);
	void sendUniform(const char *name, float x, float y);
	void sendUniform(const char *name, float x, float y, float z);
	void sendUniform(const char *name, float x, float y, float z, float w);
	void sendUniform(const char *name, int x);
	void sendUniform(const char *name, int x, int y);
	void sendUniform(const char *name, int x, int y, int z);
	void sendUniform(const char *name, int x, int y, int z, int w);
	void sendUniform(const char *name, float *m, bool transp=false, int size=4, int count = 1);

	void sendUniform(int loc, float x);
	void sendUniform(int loc, float x, float y);
	void sendUniform(int loc, float x, float y, float z);
	void sendUniform(int loc, float x, float y, float z, float w);
	void sendUniform(int loc, int x);
	void sendUniform(int loc, int x, int y);
	void sendUniform(int loc, int x, int y, int z);
	void sendUniform(int loc, int x, int y, int z, int w);
	void sendUniform(int loc, float *m, bool transp=false, int size=4, int count = 1);

	int getLoc(const char *name);


	GLhandleARB m_handle;
	bool m_bReady;
	std::string m_Name;
	std::vector<tGLSLUniform> m_Uniforms;
	std::vector<std::string> m_ShaderFileNames;
private:
};
