#pragma once
#include <math/3dmath.h>
#include <math/3dtypes.h>

class CTrackball
{
public:
	CTrackball();
	virtual ~CTrackball(void);
private:
	VECTOR4		CamTarget;
	float 		Yaw, Pitch, Roll, Radius;
	QUAT4 		Quat;
	MATRIX4x4 	XForm, ViewMatrix;

	float PanSpeed;
	float RotSpeed;
	float ZoomSpeed;

	int MouseClickX, MouseClickY;
	int MouseState;
	HWND parent;
public:
	void SetParent(HWND p);
	void OnMouseDown(int flags, int x, int y);
	void OnMouseUp(int flags, int x, int y);
	int  OnMouseMove(int flags, int x, int y);
	void ApplyXForm(void);
	void Update();

	void Pan(int x, int y);
	void PanKey(int x, int y);
	void Rotate(int x, int y);
	void Zoom(int x, int y);
	void MoveForwardBackward(float s);

	void GetCamPos(VECTOR4 *dest);
	void SetRadius(float r) {Radius = r;}
	MATRIX4x4& GetViewMatrix();


};
