
#pragma once
#include "testcopypixels.h"
#include <string>
#include <io.h>
#include <fcntl.h>

enum EShaderType
{
  PT_VERTEX_PROGRAM,
  PT_FRAGMENT_PROGRAM
};

class Shader
{
public:
  Shader(std::string &filename);     
  Shader(std::string &name,std::string &source, EShaderType type);     
  ~Shader();                  
  const std::string   &GetFileName()     {return m_fileName;};
  unsigned long GetShaderSize()         {return m_size;};  
  bool  GetStatus() {return m_status;};
  inline GLhandleARB   GetHandle()             {return m_shader;};
  inline EShaderType   GetShaderType()         {return m_programType;};            
  const std::string   &GetCompilationStatus()  {return m_logString;};
              
private:      
  void LoadProgramSize(std::string &filename);     
  GLint m_size;
  std::string m_fileName;
  bool m_status;
  EShaderType m_programType;
  std::string m_logString;
  char *m_programSource;
  GLhandleARB m_shader;      
};
